require 'swf_converter/engine/alphize'

module SwfConverter
  module ClassMethods
    attr_reader :swf_conversion_engine, :swf_conversion_options

    def converts_swfs(options={})
      options = options.dup
      engine_class = options.delete(:with)
      @swf_conversion_engine = engine_class.new if engine_class
      @swf_conversion_engine.options = options
    end
  end

  def convert_swf!
    self.class.swf_conversion_engine.convert!(self)
  end

  def self.included(base)
    base.extend(ClassMethods)
    base.converts_swfs :with => Engine::Alphize
  end

  class InvalidOptions < RuntimeError; end
end

