require 'swf_converter'

require 'swf_converter/engine/alphize/blender'

module SwfConverter
  class Engine
    attr_accessor :parent
    attr_reader :options

    def initialize
      @options = {}
    end

    def options=(new_options)
      validate_options!(new_options) if respond_to?(:validate_options!)
      @options = new_options
    end

    def convert!(swf_parent)
      raise NotImplementedError, "SwfConverter::Engine#convert! has no defined behavior. Subclass it and define your own."
    end
  end
end

