$:.unshift File.expand_path('..', __FILE__)

require 'swf_converter/engine'

class Swf
  include SwfConverter
end

class OtherSwf
  include SwfConverter
end

class VanillaSwf
  include SwfConverter
end

class DummyEngine < SwfConverter::Engine; end
class OtherDummyEngine < SwfConverter::Engine; end

class ValidatingEngine < SwfConverter::Engine
  def validate_options!(new_options)
    unless new_options[:sizes]
      raise SwfConverter::InvalidOptions, "CustomEngine requires sizes option"
    end
  end
end

class SupposedlyConvertingEngine < SwfConverter::Engine
  def convert!(swf_parent)
    # supposedly convert
  end
end

RSpec::Matchers.define :match_image do |file2|
  require 'RMagick'

  match do |file1|
    signatures = [file1, file2].map do |file_or_path|
      is_file = file_or_path.is_a? File
      if is_file
        file = file_or_path
      else
        file = File.open(file_or_path, 'r')
      end

      image = Magick::Image::from_blob(file.read)[0]
      file.close unless is_file
      signature = image.signature
      image.destroy!
      puts "#{file.path} signature: #{signature}"
      signature
    end

    signatures[0] == signatures[1]
  end
end

def example_path(subpath)
  File.expand_path(File.join('..', '..', 'examples', subpath), __FILE__)
end

