require 'spec_helper'
require 'swf_converter'

describe SwfConverter do
  it "should have alphize set by default" do
    VanillaSwf.swf_conversion_engine.should be_a SwfConverter::Engine::Alphize
  end

  it "should allow class to set its own engine" do
    Swf.converts_swfs :with => DummyEngine
    OtherSwf.converts_swfs :with => OtherDummyEngine

    Swf.swf_conversion_engine.should be_a DummyEngine
    OtherSwf.swf_conversion_engine.should be_a OtherDummyEngine
  end

  it "should allow class to set options" do
    Swf.converts_swfs :with => DummyEngine, :foo => :bar
    Swf.swf_conversion_engine.options.should == {:foo => :bar}
  end

  describe "#convert_swf!" do
    it "should call engine#convert" do
      engine_class = mock('swf_engine_requiring_conversion_class')
      engine = mock('swf_engine_requiring_conversion')
      engine.stub!(:options=)
      engine_class.stub!(:new).and_return(engine)
      Swf.converts_swfs :with => engine_class
      swf = Swf.new
      engine.should_receive(:convert!).with(swf)
      swf.convert_swf!
    end
  end
end

